BEGIN
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'SUSER_BROLE_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM SUSER_BROLE_V';
                END LOOP;
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'SOD_CASE_ACTION_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM SOD_CASE_ACTION_V';
                END LOOP;
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'SPERMISSION_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM SPERMISSION_V';
                END LOOP;
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'SUSER_NAME_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM SUSER_NAME_V';
                END LOOP;
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'ADHOC_SUSER_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM ADHOC_SUSER_V';
                END LOOP;
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'SUSER_SPERMISSION_CERT_RISK_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM SUSER_SPERMISSION_CERT_RISK_V';
                END LOOP;
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'ADHOC_APPS_SPERMISSIONS_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM ADHOC_APPS_SPERMISSIONS_V';
                END LOOP;
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'REVIEW_ITEM_STATUS_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM REVIEW_ITEM_STATUS_V';
                END LOOP;
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'ADHOC_APPS_SPERMISSIONS_ALL_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM ADHOC_APPS_SPERMISSIONS_ALL_V';
                END LOOP;
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'ACCESS_REVIEW_DETAILS_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM ACCESS_REVIEW_DETAILS_V';
                END LOOP;
                FOR k IN (SELECT null FROM all_synonyms WHERE owner = 'PUBLIC' and synonym_name = 'SHARED_ACCOUNTS_V') LOOP
                                EXECUTE IMMEDIATE 'DROP PUBLIC SYNONYM SHARED_ACCOUNTS_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'SUSER_BROLE_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW SUSER_BROLE_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'SOD_CASE_ACTION_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW SOD_CASE_ACTION_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'SPERMISSION_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW SPERMISSION_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'SUSER_NAME_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW SUSER_NAME_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'ADHOC_SUSER_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW ADHOC_SUSER_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'SUSER_SPERMISSION_CERT_RISK_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW SUSER_SPERMISSION_CERT_RISK_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'ADHOC_APPS_SPERMISSIONS_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW ADHOC_APPS_SPERMISSIONS_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'REVIEW_ITEM_STATUS_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW REVIEW_ITEM_STATUS_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'ADHOC_APPS_SPERMISSIONS_ALL_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW ADHOC_APPS_SPERMISSIONS_ALL_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'ACCESS_REVIEW_DETAILS_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW ACCESS_REVIEW_DETAILS_V';
                END LOOP;
                FOR i IN (SELECT null FROM all_views WHERE owner = user and view_name = 'SHARED_ACCOUNTS_V') LOOP
                                EXECUTE IMMEDIATE 'DROP VIEW SHARED_ACCOUNTS_V';
                END LOOP;
END;
/

CREATE VIEW suser_brole_v AS
 SELECT suser.id,
    suser.deleted,
    suser.department,
    suser.display_description,
    suser.display_name,
    suser.dn,
    suser.effective,
    suser.employee_status,
    suser.employee_type,
    suser.first_name,
    suser.full_name,
    suser.guid,
    suser.home_phone,
    suser.idm_dn,
    suser.idm_tree_name,
    suser.is_curated,
    suser.job_code,
    suser.job_title,
    suser.last_name,
    suser.location,
    suser.merged,
    suser.middle_name,
    suser.office_phone,
    suser.other_phone,
    suser.preferred_locale,
    suser.provisioning_id,
    suser.secondary_supervisor_id,
    suser.supervisor_attr_key,
    suser.supervisor_id,
    suser.supervisor_unique_id,
    suser.unique_user_id,
    suser.user_id,
    suser.business_unit,
    suser.collected_entity,
    suser.effective_entity,
    suser.identity_source,
    suser.sversion,
    suser.workforce_id,
    suser_email.email,
    suser.risk,
    brole.name business_role,
    brole.description brole_description,
    brole.risk brole_risk,
    brole.update_time brole_update_time
   FROM suser
     LEFT JOIN suser_email ON suser.id = suser_email.suser
     LEFT JOIN business_role_incl_memb br_memb ON suser.unique_user_id = br_memb.unique_member_id AND br_memb.is_user = 1
     LEFT JOIN business_role brole ON br_memb.business_role_id = brole.id
  WHERE suser.deleted = 0 AND suser.effective = 1;

CREATE VIEW suser_name_v AS 
    SELECT 
        unique_user_id, 
        display_name 
    FROM suser 
    WHERE effective = 1 and deleted = 0;

CREATE VIEW spermission_v AS
   SELECT DISTINCT spermission.id,
        spermission.account_grant,
        spermission.assignable,
        spermission.authoritative,
        TO_CHAR(spermission.bound_by_id) bound_by_id,
        spermission.boundable,
        spermission.cost,
        spermission.deleted,
        spermission.description,
        spermission.display_name,
        spermission.driver_id,
        spermission.effective,
        spermission.exclude_from_catalog,
        spermission.is_curated,
        spermission.logical_id,
        spermission.merged,
        spermission.name,
        spermission.not_reviewable,
        TO_CHAR(spermission.permission_id) permission_id,
        spermission.prov_attribute,
        spermission.prov_by_unique_permission_id,
        spermission.prov_native_value,
        spermission.prov_unique_driver_id,
        spermission.provisionable,
        spermission.risk,
        spermission.type,
        spermission.unique_bound_by_id,
        spermission.unique_permission_id,
        spermission.value,
        spermission.value_type,
        spermission.application,
        spermission.base_application,
        spermission.collected_entity,
        spermission.data_collection,
        spermission.effective_entity,
        spermission.sversion,
        spermission.auto_generated,
        spermission.prov_unique_permission_id,
        auth_by.brole_name authorized_by,
        LISTAGG(TO_CHAR(su.display_name), TO_CHAR(' | ')) WITHIN GROUP (ORDER BY su.display_name) perm_owner_name
     FROM spermission 
     LEFT JOIN (SELECT brole.brole_name, brole.unique_item_id 
            FROM (SELECT business_role_id, unique_item_id,(SELECT DISTINCT brole.name FROM business_role brole WHERE br_incl_item.business_role_id = brole.id AND brole.approval_state = 'PUBLISHED') brole_name
                FROM business_role_incl_item br_incl_item) brole, spermission       
            WHERE brole.unique_item_id = spermission.unique_permission_id AND brole.brole_name IS NOT NULL) auth_by ON auth_by.unique_item_id = spermission.unique_permission_id
      LEFT JOIN resolved_spermission_owner rso ON rso.permission = spermission.id
      LEFT JOIN suser_name_v su ON TO_CHAR(su.unique_user_id) = TO_CHAR(rso.owner_unique_id)
     WHERE spermission.deleted = 0 AND spermission.effective = 1
     GROUP BY spermission.id,
        spermission.account_grant,
        spermission.assignable,
        spermission.authoritative,
        TO_CHAR(spermission.bound_by_id),
        spermission.boundable,
        spermission.cost,
        spermission.deleted,
        spermission.description,
        spermission.display_name,
        spermission.driver_id,
        spermission.effective,
        spermission.exclude_from_catalog,
        spermission.is_curated,
        spermission.logical_id,
        spermission.merged,
        spermission.name,
        spermission.not_reviewable,
        TO_CHAR(spermission.permission_id),
        spermission.prov_attribute,
        spermission.prov_by_unique_permission_id,
        spermission.prov_native_value,
        spermission.prov_unique_driver_id,
        spermission.provisionable,
        spermission.risk,
        spermission.type,
        spermission.unique_bound_by_id,
        spermission.unique_permission_id,
        spermission.value,
        spermission.value_type,
        spermission.application,
        spermission.base_application,
        spermission.collected_entity,
        spermission.data_collection,
        spermission.effective_entity,
        spermission.sversion,
        spermission.auto_generated,
        spermission.prov_unique_permission_id,
        auth_by.brole_name
     ORDER BY spermission.name;

CREATE VIEW sod_case_action_v AS 
SELECT 
    sod_case_info.id case_number,
    sod_case_info.state case_status,
    sod_case_info.policy,
    sod_case_info.policy_name,
    sod_policy.deleted policy_status,
    sod_case_info.violator_is_user,
    sod_case_info.violator_name,
    sod_case_info.violator_title,
    sod_case_action.id action_id,
    sod_case_action.action,
    sod_case_action.action_comment,
    sod_case_action.action_time,
    suser.display_name performed_by,
    sod_case_action.control_period,
    CASE
         WHEN sod_case_action.control_period IS NOT NULL THEN sod_case_action.action_time + numtodsinterval(sod_case_action.control_period, 'day')
         ELSE TO_TIMESTAMP(NULL)
    END approval_expiration,
    sod_removal_item.type item_type,
    CASE
        WHEN ((sod_removal_item.type) = 'PERMISSION') THEN spermission_v.name
        ELSE role_policy.name
    END item_name,
    count(cri.id) AS total_number,
    (
     SELECT COUNT(*) 
     FROM sod_case_action sca2
     LEFT OUTER JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
     LEFT OUTER JOIN change_item_action cia ON cri.latest_action = cia.id
     WHERE sca2.id = sod_case_action.id AND cia.change_item_status = 'PENDING' AND cri.provisioning_type = 'MANUAL'
    ) pending_manual_number,
    (
     SELECT COUNT(*) 
     FROM sod_case_action sca2
     LEFT OUTER JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
     LEFT OUTER JOIN change_item_action cia ON cri.latest_action = cia.id
     WHERE sca2.id = sod_case_action.id AND cia.change_item_status = 'PENDING' AND cri.provisioning_type = 'IDENTITY_MANAGER'
    ) pending_idm_number,
    (
     SELECT COUNT(*) 
     FROM sod_case_action sca2
     LEFT OUTER JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
     LEFT OUTER JOIN change_item_action cia ON cri.latest_action = cia.id
     WHERE sca2.id = sod_case_action.id AND cia.change_item_status = 'PENDING' AND cri.provisioning_type = 'EXTERNAL_WORKFLOW'
    ) pending_ext_number,
    (
     SELECT COUNT(*) 
     FROM sod_case_action sca2
     LEFT OUTER JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
     LEFT OUTER JOIN change_item_action cia ON cri.latest_action = cia.id
     WHERE sca2.id = sod_case_action.id AND cia.change_item_status = 'INITIALIZED' 
    ) initialized_number,
    (
     SELECT COUNT(*) 
     FROM sod_case_action sca2
     LEFT OUTER JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
     LEFT OUTER JOIN change_item_action cia ON cri.latest_action = cia.id
     WHERE sca2.id = sod_case_action.id AND cia.change_item_status = 'VERIFIED' 
    ) verified_number,
    (
     SELECT COUNT(*) 
     FROM sod_case_action sca2
     LEFT OUTER JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
     LEFT OUTER JOIN change_item_action cia ON cri.latest_action = cia.id
     WHERE sca2.id = sod_case_action.id AND cia.change_item_status = 'REFUSED' 
    ) refused_number,
    (
     SELECT COUNT(*) 
     FROM sod_case_action sca2
     LEFT OUTER JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
     LEFT OUTER JOIN change_item_action cia ON cri.latest_action = cia.id
     WHERE sca2.id = sod_case_action.id AND cia.change_item_status = 'VERIFICATION_IGNORED' 
    ) verification_ignored_number,
    (
     SELECT COUNT(*) 
     FROM sod_case_action sca2
     LEFT OUTER JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
     LEFT OUTER JOIN change_item_action cia ON cri.latest_action = cia.id
     WHERE sca2.id = sod_case_action.id AND cia.change_item_status = 'NOT_VERIFIED' 
    ) not_verified_number,
    (
     SELECT COUNT(*) 
     FROM sod_case_action sca2
     LEFT OUTER JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
     LEFT OUTER JOIN change_item_action cia ON cri.latest_action = cia.id
     WHERE sca2.id = sod_case_action.id AND cia.change_item_status = 'VERIFICATION_TIMEOUT' 
    ) verification_timeout_number,
    (
     SELECT COUNT(*) 
     FROM sod_case_action sca2
     LEFT OUTER JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
     LEFT OUTER JOIN change_item_action cia ON cri.latest_action = cia.id
     WHERE sca2.id = sod_case_action.id AND cia.change_item_status = 'ERROR' 
    ) error_number,
    (
     SELECT COUNT(*) 
     FROM sod_case_action sca2
     LEFT OUTER JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
     LEFT OUTER JOIN change_item_action cia ON cri.latest_action = cia.id
     WHERE sca2.id = sod_case_action.id AND cia.change_item_status = 'COMPLETED' AND cri.provisioning_type = 'MANUAL'
    ) completed_manual_number,
    (
     SELECT COUNT(*) 
     FROM sod_case_action sca2
     LEFT OUTER JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
     LEFT OUTER JOIN change_item_action cia ON cri.latest_action = cia.id
     WHERE sca2.id = sod_case_action.id AND cia.change_item_status = 'COMPLETED' AND cri.provisioning_type = 'IDENTITY_MANAGER'
    ) completed_idm_number,
    (
     SELECT COUNT(*) 
     FROM sod_case_action sca2
     LEFT OUTER JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
     LEFT OUTER JOIN change_item_action cia ON cri.latest_action = cia.id
     WHERE sca2.id = sod_case_action.id AND cia.change_item_status = 'COMPLETED' AND cri.provisioning_type = 'EXTERNAL_WORKFLOW'
    ) completed_ext_number,
    (
     SELECT COUNT(*) 
     FROM sod_case_action sca2
     LEFT OUTER JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
     LEFT OUTER JOIN change_item_action cia ON cri.latest_action = cia.id
     WHERE sca2.id = sod_case_action.id AND cia.change_item_status = 'IN_PROGRESS' 
    ) in_progress_number
   FROM sod_case_info
     JOIN sod_policy ON sod_policy.id = sod_case_info.policy
     JOIN sod_case_action ON sod_case_action.sod_case = sod_case_info.id
     LEFT JOIN sod_removal_item ON sod_removal_item.sod_case_action = sod_case_action.id
     LEFT JOIN spermission_v ON spermission_v.unique_permission_id = sod_removal_item.unique_id
     LEFT JOIN role_policy ON role_policy.unique_policy_id = sod_removal_item.unique_id AND role_policy.deleted = 0
     LEFT JOIN suser ON sod_case_action.performed_by = suser.unique_user_id AND suser.deleted = 0 AND suser.effective = 1
     LEFT JOIN change_request_item cri ON cri.sod_case_action = sod_case_action.id
   GROUP BY sod_case_info.id, sod_case_info.state, sod_case_info.policy, sod_case_info.policy_name, sod_policy.deleted, sod_case_info.violator_is_user, sod_case_info.violator_name, sod_case_info.violator_title, sod_case_action.id, sod_case_action.action, sod_case_action.action_comment, sod_case_action.action_time, suser.display_name, sod_case_action.control_period, spermission_v.name, role_policy.name, sod_removal_item.type
  ORDER BY sod_case_info.policy_name, sod_case_info.policy, sod_case_info.violator_name, sod_case_action.action_time;

CREATE VIEW shared_accounts_v AS 
  SELECT acct.id,
    acct.unique_account_id,
    acct.name,
    acct.collected_entity,
    acct.effective_entity,
    acct.sversion saccount_sversion,
    saccu.suser,
    saccu.sversion saccount_user_sversion,
    suser.display_name
   FROM saccount acct
     LEFT JOIN saccount_user saccu ON acct.collected_entity = saccu.saccount
     LEFT JOIN ( SELECT max(saccu2.sversion) max_sversion
           FROM saccount_user saccu2) version ON version.max_sversion = saccu.sversion
     LEFT JOIN suser suser ON suser.id = saccu.suser
  WHERE acct.relation_to_user_type = 'SHARED' AND saccu.effective = 0 AND acct.virtual = 0 AND acct.effective = 1
  ORDER BY acct.name, suser.display_name;

CREATE VIEW access_review_details_v AS 
 SELECT DISTINCT
  item.id review_item_id,
  item.last_override_action_id last_override_action,
  instance.id review_instance_id,
  instance.status review_status,
  instance.start_date,
  instance.end_date,
  instance.valid_to_date,
  instance.item_count,
  multi_owner.review_owners,
  multi_reviewer.reviewer_ids reviewer_id,
      CASE
          WHEN item.final_cert_by_unique_user_id IS NOT NULL THEN TO_CHAR(final_reviewer.display_name)
          ELSE TO_CHAR(multi_reviewer.reviewers)
      END reviewer_display_name,
  reassigned_by_history.reviewers reassigned_by_user_disp_name,
  reassigned_from_history.reviewers reassigned_from_user_disp_name,
  reassigned_by_history.reassigned_date,
  defn.name review_name,
  TO_CHAR(substr(defn.description,0,4000)) description,
  defn.review_type,
  defn.next_schedule_date,
  CASE
      WHEN item_type = 'ACCOUNT' AND usr.id IS NULL THEN shacc.suser  
      ELSE usr.id
  END user_id,
  CASE
      WHEN item_type = 'ACCOUNT' AND usr.display_name IS NULL THEN TO_CHAR(shacc.display_name)
      ELSE TO_CHAR(usr.display_name)
  END user_display_name,
  action.action reviewer_action,
  action.review_order,
  action.reviewer_comment,
  perm.id permission_id,
  perm.name permission_name,
  acct.id account_id,
  acct.account_id account_native_id,
  acct.name account_name,
  acct.relation_to_user_type account_relation,
  TO_CHAR(app.id) application_id,
  TO_CHAR(app_ds.name) application_name,
  item.final_decision,
  item.final_decision_time,
  role.id role_id,
  role.name role_name,
  item.item_type,
  brole.name brole_name,
  action.fulfillment_instructions,
  esc_reviewer.display_name
 FROM review_item item
   JOIN review_instance instance ON item.review_instance_id = instance.id
   JOIN review_definition defn ON instance.review_definition = defn.id 
   LEFT JOIN suser usr ON usr.unique_user_id = item.unique_user_id AND usr.effective = 1
   LEFT JOIN spermission perm ON perm.unique_permission_id = item.unique_permission_id AND perm.effective = 1
   LEFT JOIN saccount acct ON acct.unique_account_id = item.unique_account_id AND acct.effective = 1
   LEFT JOIN application app ON app.id =
      CASE
          WHEN perm.id IS NULL THEN acct.application
          ELSE perm.application
      END
   LEFT JOIN business_role brole ON brole.id = item.business_role_id
   LEFT JOIN role_policy role ON role.id = item.role_id
   LEFT JOIN data_source app_ds ON app_ds.id = app.id
   LEFT JOIN review_item_action action ON action.review_item_id = item.id AND action.action <> 'REASSIGNED'
   LEFT JOIN reviewer_instance inst2 ON instance.id = inst2.review_instance_id AND inst2.type = 'RO'
   LEFT JOIN reviewer_instance inst3 ON instance.id = inst3.review_instance_id
   LEFT JOIN ( SELECT DISTINCT 
            item.id item_id,
            LISTAGG((TO_CHAR(multi_reviewers.id)), ' | ') WITHIN GROUP(ORDER BY multi_reviewers.id) reviewer_ids,
            LISTAGG((TO_CHAR(multi_reviewers.unique_user_id)), ' | ') WITHIN GROUP(ORDER BY multi_reviewers.unique_user_id) reviewer_unique_ids,
            LISTAGG((TO_CHAR(multi_reviewers.display_name)), ' | ') WITHIN GROUP(ORDER BY multi_reviewers.display_name) reviewers
          FROM review_item item
          LEFT JOIN reviewer_user_instance rrui ON rrui.reviewer_instance_id = item.curr_reviewer_instance_id
          LEFT JOIN suser multi_reviewers ON rrui.unique_user_id = multi_reviewers.unique_user_id AND multi_reviewers.effective = 1
          GROUP BY item.id) multi_reviewer ON multi_reviewer.item_id = item.id
   LEFT JOIN suser final_reviewer ON item.final_cert_by_unique_user_id = final_reviewer.unique_user_id AND final_reviewer.effective = 1
   LEFT JOIN suser acting_reviewer ON action.acted_by_user_unique_id = acting_reviewer.unique_user_id AND acting_reviewer.effective = 1
   LEFT JOIN review_item_action reassigned ON reassigned.review_item_id = item.id AND reassigned.action = 'REASSIGNED' AND reassigned.reassigned_to_user_unique_id LIKE '%' || multi_reviewer.reviewer_unique_ids || '%'
   LEFT JOIN suser curr_reviewer ON curr_reviewer.unique_user_id LIKE '%' || multi_reviewer.reviewer_unique_ids || '%' AND curr_reviewer.effective = 1
   LEFT JOIN (SELECT DISTINCT 
    ria.review_item_id,
    LISTAGG(TO_CHAR(usr.display_name), ' | ') WITHIN GROUP(ORDER BY ria.assigned) AS reviewers
    FROM  review_item_action ria
    LEFT JOIN reviewer_instance ri ON ri.id = ria.reviewer_instance_id
    LEFT JOIN suser usr ON ri.single_reviewer_unique_id = usr.unique_user_id AND usr.effective = 1
    WHERE ria.action = 'REASSIGNED'
    GROUP BY ria.review_item_id) reassigned_from_history ON reassigned_from_history.review_item_id = item.id
   LEFT JOIN (SELECT DISTINCT 
    ria.review_item_id,
    LISTAGG(TO_CHAR(usr.display_name), ' | ') WITHIN GROUP(ORDER BY ria.assigned) AS reviewers,
    LISTAGG(TO_CHAR(CAST(ria.assigned AS DATE), 'YYYY-MM-DD HH24:MI:SS'), ' | ') WITHIN GROUP(ORDER BY ria.assigned) AS reassigned_date
    FROM  review_item_action ria
    LEFT JOIN suser usr ON ria.reassigned_by_user_unique_id = usr.unique_user_id AND usr.effective = 1
    WHERE ria.action = 'REASSIGNED'
    GROUP BY ria.review_item_id) reassigned_by_history ON reassigned_by_history.review_item_id = item.id
   LEFT JOIN shared_accounts_v shacc ON shacc.unique_account_id = acct.unique_account_id
   LEFT JOIN ( SELECT DISTINCT defn_1.name review_name,
          ri.id rid,
          LISTAGG((TO_CHAR(s.display_name)), ' | ') WITHIN GROUP(ORDER BY s.display_name) review_owners
         FROM review_instance ri
           JOIN review_definition defn_1 ON ri.review_definition = defn_1.id
           LEFT JOIN reviewer_instance rev_owner ON ri.id = rev_owner.review_instance_id AND rev_owner.type = 'RO'
           LEFT JOIN reviewer_user_instance rui ON rui.reviewer_instance_id = rev_owner.id
           LEFT JOIN suser s ON rui.unique_user_id = s.unique_user_id AND s.effective = 1
        GROUP BY defn_1.name, ri.id) multi_owner ON multi_owner.rid = item.review_instance_id   
   LEFT JOIN (SELECT 
    esc_reviewers.review_instance_id,
    LISTAGG(TO_CHAR(esc_reviewers.display_name), ' | ') WITHIN GROUP (ORDER BY esc_reviewers.display_name) display_name
    FROM
      (SELECT DISTINCT
            TO_CHAR(u.display_name) display_name,
            rri.review_instance_id
      FROM review_item ri
      JOIN reviewer_instance rri ON ri.curr_reviewer_instance_id = rri.id AND rri.type = 'EO'
      JOIN reviewer_user_instance rriu ON rriu.reviewer_instance_id = rri.id
      JOIN suser u ON u.unique_user_id = rriu.unique_user_id AND u.effective = 1) esc_reviewers
    GROUP BY esc_reviewers.review_instance_id) esc_reviewer ON esc_reviewer.review_instance_id = item.review_instance_id
WHERE defn.deleted = 0 AND (acting_reviewer.unique_user_id LIKE '%' || multi_reviewer.reviewer_unique_ids || '%' OR acting_reviewer.unique_user_id IS NULL AND action.review_order = (( SELECT DISTINCT min(act.review_order) min
         FROM review_item_action act
        WHERE (act.action = 'PENDING' OR act.action = 'ESCALATE') AND act.review_item_id = item.id)) OR acting_reviewer.unique_user_id IS NOT NULL AND action.shared_queue = 1) AND (action.action <> 'PENDING' OR item.final_decision IS NULL)
ORDER BY item.id, action.review_order;

CREATE VIEW review_item_status_v AS 
  SELECT DISTINCT
    item.id review_item_id,
    instance.id review_instance_id,
    instance.status review_status,
    instance.start_date,
    instance.end_date,
    instance.item_count,
    CASE
        WHEN item_type = 'ACCOUNT' AND usr.id IS NULL THEN shacc.suser  
        ELSE usr.id
    END user_id,
    CASE
        WHEN item_type = 'ACCOUNT' AND usr.display_name IS NULL THEN TO_CHAR(shacc.display_name)
        ELSE TO_CHAR(usr.display_name)
    END user_display_name,
    perm.id permission_id,
    perm.name permission_name
   FROM review_item item
     JOIN review_instance instance ON item.review_instance_id = instance.id
     LEFT JOIN suser usr ON usr.unique_user_id = item.unique_user_id AND usr.effective = 1
     LEFT JOIN spermission perm ON perm.unique_permission_id = item.unique_permission_id AND perm.effective = 1
     LEFT JOIN saccount acct ON acct.unique_account_id = item.unique_account_id AND acct.effective = 1
     LEFT JOIN shared_accounts_v shacc ON shacc.unique_account_id = acct.unique_account_id
   WHERE instance.status = 'CERTIFIED' OR instance.status = 'CERTIFYING' OR instance.status = 'AUDIT_APPROVAL'
   ORDER BY item.id;

CREATE VIEW adhoc_apps_spermissions_v AS  
 SELECT DISTINCT suser_account_permission.suser,
 suser_account_permission.saccount,
    data_source.id  application_id,
    data_source.name  application_name,
  to_char(data_source.description )    application_description,
    application.risk  application_risk,
    spermission.id  permission_id,
    spermission.name  permission_name,
    spermission.description  permission_description,
    spermission.risk  permission_risk,
    spermission.type  permission_type,
    max(review_instance.end_date)  last_certification,
        CASE
            WHEN max(review_instance.end_date) IS NOT NULL THEN 1
            ELSE 0
        END is_certified,
        CASE
           WHEN pending.user_id IS NOT NULL THEN 1
            ELSE 0
        END  certification_pending
   FROM suser_account_permission
     LEFT JOIN spermission ON suser_account_permission.spermission = spermission.id
     LEFT JOIN application ON spermission.application = application.id
     LEFT JOIN data_source ON application.id = data_source.id
    LEFT JOIN review_item_status_v certified ON suser_account_permission.suser = certified.user_id AND spermission.id = certified.permission_id AND certified.review_status = 'CERTIFIED'
     LEFT JOIN review_instance ON certified.review_instance_id = review_instance.id
    LEFT JOIN review_item_status_v pending ON suser_account_permission.suser = pending.user_id AND spermission.id = pending.permission_id AND pending.review_status = 'CERTIFYING' OR pending.review_status = 'AUDIT_APPROVAL'
  WHERE spermission.deleted = 0 AND spermission.effective = 1
  AND data_source.data_source_type = 'APPLICATION' AND data_source.deleted = 0
  GROUP BY suser_account_permission.suser, suser_account_permission.saccount, 
  data_source.id, data_source.name,
  to_char(data_source.description),
  application.risk,
  spermission.id, spermission.name, spermission.description, spermission.risk, 
  spermission.type, pending.user_id;
  
  CREATE VIEW suser_spermission_cert_risk_v AS 
  SELECT DISTINCT suser.id AS suser_id,
  ( SELECT count(spermissions_1.suser)  count
         FROM adhoc_apps_spermissions_v spermissions_1
        WHERE spermissions_1.suser = suser.id AND spermissions_1.last_certification IS NOT NULL)  certification_count,
      CASE
          WHEN spermissions.is_certified IS NULL THEN 0
          ELSE spermissions.is_certified
      END  is_certified,
      CASE
          WHEN spermissions.certification_pending IS NULL THEN 0
          ELSE spermissions.certification_pending
      END  certification_pending,

              CASE
                  WHEN sum(spermissions.permission_risk) IS NULL THEN 0
                  ELSE sum(spermissions.permission_risk)
              END   aggregate_permission_risk
  FROM suser
   LEFT JOIN adhoc_apps_spermissions_v spermissions ON spermissions.suser = suser.id
  WHERE suser.deleted = 0 AND suser.effective = 1
  GROUP BY suser.id, spermissions.is_certified, spermissions.certification_pending;

CREATE VIEW adhoc_suser_v AS 
  SELECT suser.id,
    suser.deleted,
    suser.department,
    suser.display_description,
    suser.display_name,
    suser.dn,
    suser.effective,
    suser.employee_status,
    suser.employee_type,
    suser.first_name,
    suser.full_name,
    suser.guid,
    suser.home_phone,
    suser.idm_dn,
    suser.idm_tree_name,
    suser.is_curated,
    suser.job_code,
    suser.job_title,
    suser.last_name,
    suser.location,
    suser.merged,
    suser.middle_name,
    suser.office_phone,
    suser.other_phone,
    suser.preferred_locale,
    suser.provisioning_id,
    suser.secondary_supervisor_id,
    suser.supervisor_attr_key,
    suser.supervisor_id,
    suser.supervisor_unique_id,
    suser.unique_user_id,
    suser.user_id,
    suser.business_unit,
    suser.collected_entity,
    suser.effective_entity,
    suser.identity_source,
    suser.sversion,
    suser.workforce_id,
    suser_email.email,
    suser.risk,
    cert_risk.certification_count,
    cert_risk.is_certified,
    cert_risk.certification_pending,
    cert_risk.aggregate_permission_risk,
    listagg(perm.name, ' | ') WITHIN GROUP (ORDER BY perm.name)  all_permissions,
    brole.name  business_role,
    brole.description  brole_description,
    brole.risk  brole_risk,
    brole.update_time  brole_update_time
   FROM suser
     LEFT JOIN suser_email ON suser.id = suser_email.suser
     LEFT JOIN spermission perm ON (EXISTS ( SELECT suser_account_permission.suser
           FROM suser_account_permission
          WHERE suser.id = suser_account_permission.suser)) AND perm.deleted = 0 AND perm.effective = 1
     LEFT JOIN suser_spermission_cert_risk_v cert_risk ON suser.id = cert_risk.suser_id
     LEFT JOIN business_role brole ON (EXISTS ( SELECT br_memb.business_role_id
           FROM business_role_incl_memb br_memb
          WHERE suser.unique_user_id = br_memb.unique_member_id AND br_memb.is_user = 1 AND br_memb.business_role_id = brole.id))
  WHERE suser.deleted = 0 AND suser.effective = 1
  GROUP BY suser.id, suser.deleted, suser.department, suser.display_description, brole.name, brole.description, brole.risk, brole.update_time, 
  suser.display_name, suser.dn, suser.effective, suser.employee_status, suser.employee_type, suser.first_name, suser.full_name, suser.guid, 
  suser.home_phone, suser.idm_dn, suser.idm_tree_name, suser.is_curated, suser.job_code, suser.job_title, suser.last_name, suser.location, 
  suser.merged, suser.middle_name, suser.office_phone, suser.other_phone, suser.preferred_locale, suser.provisioning_id, suser.secondary_supervisor_id,
  suser.supervisor_attr_key, suser.supervisor_id, suser.supervisor_unique_id, suser.unique_user_id, suser.user_id, suser.business_unit, suser.collected_entity,
  suser.effective_entity, suser.identity_source, suser.sversion, suser.workforce_id, perm.name,suser.risk,
  suser_email.email, cert_risk.certification_count, cert_risk.is_certified, cert_risk.certification_pending, cert_risk.aggregate_permission_risk;

GRANT SELECT ON igops.suser_brole_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM suser_brole_v for igops.suser_brole_v;

GRANT SELECT ON igops.suser_name_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM suser_name_v for igops.suser_name_v;

GRANT SELECT ON igops.spermission_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM spermission_v for igops.spermission_v;

GRANT SELECT ON igops.sod_case_action_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM sod_case_action_v for igops.sod_case_action_v;

GRANT SELECT ON igops.shared_accounts_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM shared_accounts_v for igops.shared_accounts_v;

GRANT SELECT ON igops.access_review_details_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM access_review_details_v for igops.access_review_details_v;

GRANT SELECT ON igops.review_item_status_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM review_item_status_v FOR igops.review_item_status_v;

GRANT SELECT ON igops.adhoc_apps_spermissions_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM adhoc_apps_spermissions_v FOR igops.adhoc_apps_spermissions_v;

GRANT SELECT ON igops.suser_spermission_cert_risk_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM suser_spermission_cert_risk_v FOR igops.suser_spermission_cert_risk_v;

GRANT SELECT ON igops.adhoc_suser_v TO igrptuser;
CREATE OR REPLACE PUBLIC SYNONYM adhoc_suser_v FOR igops.adhoc_suser_v;